# Outline Class Reference

`#include <outline.h>`

Inheritance diagram for Outline:

List of all members.

## Public Member Functions

| Outline ()
void | sync ()
| Updates the polygon data to match the parameters.
virtual bool | set_param (const String &param, const synfig::ValueBase &value)
| Sets the parameter described by param to value.
virtual ValueBase | get_param (const String &param) const
| Get the value of the specified parameter.
virtual Vocab | get_param_vocab () const
| Gets the parameter vocabulary.
virtual void | set_time (Context context, Time time) const
| Sets the time for the selected Layer and those under it.
virtual void | set_time (Context context, Time time, Vector pos) const
virtual bool | set_version (const String &ver)
| Sets the virtual version to use for backwards-compatibility.
virtual void | reset_version ()
| Resets the virtual version.

## Constructor & Destructor Documentation

Outline::Outline | ( |  | ) |

References synfig::Layer_Polygon::clear(), and f.

## Member Function Documentation

void Outline::sync | ( |  | ) |

Updates the polygon data to match the parameters.

The Sync() function takes the values and creates a polygon to be rendered with the polygon layer.

Reimplemented from synfig::Layer_Polygon.

References synfig::Layer_Polygon::add_polygon(), synfig::Layer_Polygon::clear(), synfig::convert_bline_to_segment_list(), synfig::convert_bline_to_width_list(), CUSP_TANGENT_ADJUST, CUSP_THRESHOLD, EPSILON, synfig::error(), f, synfig::ValueBase::get_contained_type(), synfig::Layer::get_description(), synfig::ValueBase::get_list(), synfig::ValueBase::get_loop(), synfig::Vector::is_equal_to(), line_intersection(), synfig::Vector::mag(), N_, NO_LOOP_COOKIE, synfig::Vector::norm(), synfig::Vector::perp(), ROUND_END_FACTOR, SAMPLES, synfig::ValueBase::set_loop(), SPIKE_AMOUNT, synfig::warning(), and zero().

Referenced by set_time().

bool Outline::set_param | ( | const String & | param,
|  | const synfig::ValueBase & | value |
| ) |  |  | `[virtual]`

Sets the parameter described by param to value.

Parameters:

  | param | The name of the parameter to set
  | value | What the parameter is to be set to.

Returns:
  `true` on success, `false` upon rejection or failure. If it returns `false`, then the Layer is assumed to remain unchanged.

See also:
  get_param()

Todo:
  param should be of the type `const String &param`

Reimplemented from synfig::Layer_Polygon.

References synfig::Layer::connect_dynamic_param(), synfig::Layer::disconnect_dynamic_param(), synfig::Layer::dynamic_param_list(), synfig::ValueBase::get_type(), IMPORT, IMPORT_PLUS, and synfig::warning().

ValueBase Outline::get_param | ( | const String & | param | ) | const`[virtual]`

Get the value of the specified parameter.

Returns:
  The requested parameter value, or (upon failure) a NIL ValueBase.

See also:
  set_param()

Todo:
  param should be of the type `const String &`

Reimplemented from synfig::Layer_Polygon.

References EXPORT, EXPORT_NAME, and EXPORT_VERSION.

Layer::Vocab Outline::get_param_vocab | ( | void |  | ) | const`[virtual]`

Gets the parameter vocabulary.

Reimplemented from synfig::Layer_Polygon.

References _, and synfig::Layer::set_description().

void Outline::set_time | ( | Context | context,
|  | Time | time |
| ) |  |  | const`[virtual]`

Sets the time for the selected Layer and those under it.

Parameters:

  | context | Context iterator referring to next Layer.
  | time | writeme

See also:
  Handle::set_time()

Reimplemented from synfig::Layer.

References synfig::Context::set_time(), and sync().

void Outline::set_time | ( | Context | context,
|  | Time | time,
|  | Vector | pos |
| ) |  |  | const`[virtual]`

References synfig::Context::set_time(), and sync().

virtual bool Outline::set_version | ( | const String & | ver | ) | `[inline, virtual]`

Sets the virtual version to use for backwards-compatibility.

See also:
  reset_version()

Reimplemented from synfig::Layer.

virtual void Outline::reset_version | ( |  | ) | `[inline, virtual]`

Resets the virtual version.

See also:
  set_version()

Reimplemented from synfig::Layer.

The documentation for this class was generated from the following files:

- outline.h
- outline.cpp